package pl.net.linux.krzak.kchat.applet;

import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.Component;
import java.awt.Frame;
import java.awt.TextArea;
import java.awt.TextField;
import java.awt.Panel;
import java.awt.BorderLayout;
import java.awt.Font;
import java.awt.Color;
import java.lang.String;
import java.util.Vector;

public class MsgFloatingWindow extends Frame implements WindowListener, ActionListener {
    public String nick = "";
    public String title = "";
    public Frame  fr = null;
    public TextArea text = null;
    private TextField input = null;
    private kChatApplet applet = null;

    MsgFloatingWindow(String title, String nick,kChatApplet a) {     // konstructor
	super("MsgFloatingWindow");
	this.applet = a;
	this.title = title;
	this.nick  = nick;
	this.fr = new Frame(title);
	this.fr.setSize(400,250);
	this.fr.addWindowListener(this);

	this.text = new TextArea("",10,10,TextArea.SCROLLBARS_VERTICAL_ONLY);
	this.text.setEditable(false);
        this.text.setBackground(applet.background);
	this.text.setForeground(applet.foreground);

	this.input = new TextField("",10);
	this.input.setFont(new Font("fixed", Font.BOLD, 12));
	this.input.addActionListener(this);
        this.input.setBackground(applet.background);
	this.input.setForeground(applet.foreground);
//	this.input.addFocusListener(this);
//	this.input.requestFocus();

	Panel panel = new Panel(new BorderLayout());
	panel.add(this.text,BorderLayout.CENTER);
	panel.add(this.input,BorderLayout.SOUTH);

	this.fr.add(panel);

	// dodaje do listy nikow
	applet.windowsList.addElement(this);
    }



    public void setVisible(boolean state) {
    if (this.fr != null) this.fr.setVisible(state);
    }


    // ***********
    // WINDOW
    // ***********
    public void windowClosing(WindowEvent e) {
	for (int i=0; i < applet.windowsList.size(); i++){
	    MsgFloatingWindow tmpMFW = (MsgFloatingWindow)applet.windowsList.elementAt(i);
	    if (tmpMFW.nick.equals(nick)) applet.windowsList.removeElementAt(i);
 
	    }
	this.fr.dispose();
    }

    public void windowClosed(WindowEvent e) { }
    public void windowOpened(WindowEvent e) { }
    public void windowIconified(WindowEvent e) { }
    public void windowDeiconified(WindowEvent e) { }

    public void windowActivated(WindowEvent e) {
	for (int i = 0; i < applet.nList.getItemCount();i++)
	    if (applet.nList.getItem(i).equals(this.nick)) applet.nList.select(i);
	input.requestFocus();
    }

    public void windowDeactivated(WindowEvent e) {
	for (int i = 0; i < applet.nList.getItemCount();i++)
	    if (applet.nList.getItem(i).equals(this.nick)) applet.nList.deselect(i);
    }


    // ***********
    // INPUT
    // ***********
      public void actionPerformed(ActionEvent e) {
	applet.net.send("*MSG|"+ applet.login + "|"+ this.nick + "|" + e.getActionCommand()+"|black|");
	String s = "<" + applet.login + "> " + e.getActionCommand()+"\n";
	this.text.append(s);
	this.input.setText("");
	this.text.setCaretPosition((this.text.getText()).length());
      }

}
