package pl.net.linux.krzak.kchat.server;
import java.net.*;
import java.io.*;

public class kChatServer
{

    static kChatSystem systemClass =null;
    static int ping_timeout = 40000;
    static kChatPing ping = null;
    static int nrPortu = 1979;
    
/*************************************************************************************/
	public static void main(String args[]) throws IOException
	{
		ServerSocket serverS = null;
		boolean listening = true;

		systemClass = new kChatSystem();
		if ((args.length>0) && (!args[0].equals("")))
		    configFileParse(args[0]);
		    else
		    configFileParse("./kChat.conf");


		try
 {
		    serverS = new ServerSocket(nrPortu);
		    System.out.println("kChat Server Listen at port " + nrPortu);
		}
 catch (IOException e)
 {
		    System.out.println("Listen at " + nrPortu + " impossible, i don't know why ! " + e);
		    System.exit(1);
		}

		new kChatPing(systemClass,ping_timeout-1000).start();

		try 
		{
		    while (true) {
		    Socket socket = serverS.accept();
		    socket.setSoTimeout(ping_timeout);
			try {
			 new kChatServerThread(socket,systemClass);
			} catch (IOException e) {
			 socket.close();
			}
		    }
		} finally { 
		    serverS.close(); 
		}
	}

/*************************************************************************************/
	private static void configFileParse(String filename) {
	    try {
	    FileReader fr = new FileReader(filename);
	    BufferedReader frb = new BufferedReader(fr);

	    String line = new String("");
	    while (line!=null) {
		line = frb.readLine();
		if ((line!=null)&&(!line.startsWith("#"))&&(!line.equals(""))) {
		    String command = line.substring(0,line.indexOf("=",0));
		    String value   = line.substring(line.indexOf("=",0)+1);
		    if (command.equals("log-channel-file")) systemClass.logfile=value;
		    if (command.equals("log-channel")) systemClass.log=value;
		    if (command.equals("reserved-nicks-list-file")) systemClass.rnicksFilename=value;
		    if (command.equals("moderator-passwords-file")) systemClass.passwdfile=value;
		    if (command.equals("ping-timeout")) ping_timeout=new Integer(value).parseInt(value);
		    if (command.equals("logout-file")) systemClass.logoutFilename = value;
		    if (command.equals("log-level")) systemClass.logLevel = new Integer(value).parseInt(value);
		    if (command.equals("port")) nrPortu=new Integer(value).parseInt(value);
		    // LANG TXT
		    if (command.equals("langfile")) {
			    try {
    			    FileReader frlang = new FileReader(value);
    			    BufferedReader frblang = new BufferedReader(frlang);
			    String linelang = new String();
		    	    while (linelang!=null) {
				linelang = frblang.readLine();
		    		if ((linelang!=null)&&(!linelang.startsWith("#"))&&(!linelang.equals(""))) {
		    		    String txttmp = linelang.substring(0,linelang.indexOf("=",0));
				    String valtmp = linelang.substring(linelang.indexOf("=",0)+1);
				    if (txttmp.equals("WELCOME")) systemClass.TXT[0] = valtmp;
				    if (txttmp.equals("END")) systemClass.TXT[1] = valtmp;
				    if (txttmp.equals("JOIN")) systemClass.TXT[2] = valtmp;
				    if (txttmp.equals("MODERINFO")) systemClass.TXT[3] = valtmp;
				    if (txttmp.equals("NOMODERINFO")) systemClass.TXT[4] = valtmp;
				    if (txttmp.equals("LOGOUT")) systemClass.TXT[5] = valtmp;
				    if (txttmp.equals("PRIVBUTTON")) systemClass.TXT[6] = valtmp;
				    if (txttmp.equals("MODERBUTTON")) systemClass.TXT[7] = valtmp;
				    if (txttmp.equals("LOGOUTBUTTON")) systemClass.TXT[8] = valtmp;
				    if (txttmp.equals("CLOSEBUTTON")) systemClass.TXT[9] = valtmp;
				    if (txttmp.equals("MODERTITLE")) systemClass.TXT[10] = valtmp;
				    if (txttmp.equals("LOGINBUSY")) systemClass.TXT[11] = valtmp;
				    if (txttmp.equals("PRIVTITLE")) systemClass.TXT[12] = valtmp;
				    if (txttmp.equals("PASSTITLE")) systemClass.TXT[13] = valtmp;
				    if (txttmp.equals("YOUMODERATOR")) systemClass.TXT[14] = valtmp;
				    if (txttmp.equals("KICKED")) systemClass.TXT[15] = valtmp;
				    if (txttmp.equals("KICKBUTTON")) systemClass.TXT[16] = valtmp;
				    if (txttmp.equals("TOPICBUTTON")) systemClass.TXT[17] = valtmp;
				    if (txttmp.equals("DISCONNECT")) systemClass.TXT[18] = valtmp;
				    }
				}
			    }
			    catch (IOException e) { System.out.println("Check langfile option !!!"); }
			}
		    }
		}
	    } catch (IOException e) { e.printStackTrace(); }
	}


}
